﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Models.Obj;
using SlimDX;

namespace Models.Aqo
{
    using Vertex = Tuple<Vector3, Vector3, Vector3>;

    public class MeshBuilder<T>
    {
        public Dictionary<T, int>       VertexMap               { get; set; }
        public List<T>                  Vertices                { get; set; }
        public List<int>                Indices                 { get; set; }

        public MeshBuilder()
        {
            VertexMap   = new Dictionary<T, int>();
            Vertices    = new List<T>();
            Indices     = new List<int>();
        }

        public IEnumerable<int> AddRange(IEnumerable<T> v)
        {
            foreach(var i in v)
                yield return Add(i);
        }

        public void Add(T v0, T v1, T v2)
        {
            Add(v0);
            Add(v1);
            Add(v2);
        }

        public int Add(T v)
        {
            int index;

            if(!VertexMap.TryGetValue(v, out index))
            {
                VertexMap.Add(v, index= VertexMap.Count);
                Vertices.Add(v);
            }

            Indices.Add(index);

            return index;
        }
    }
}
